/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2010-2012 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 */
package org.ow2.jonas.admin.autostart.control {
import com.adobe.cairngorm.control.CairngormEventDispatcher;
import com.adobe.cairngorm.control.FrontController;

import org.ow2.jonas.admin.autostart.command.*;
import org.ow2.jonas.admin.autostart.event.*;

/**
 * Bind a type of command to an action.
 */
public class Controller extends FrontController {

    /**
     * Create an instance of the controller. Commands are initialized here.
     */
    public function Controller(dispatcher:CairngormEventDispatcher) {
        super(dispatcher);
    }

    /**
     * Add all the commands to the pool of commands.
     */
    public function initialiseCommands():void {
        this.addCommand(BuilderEvent.EVENT_AVAILABLE_APPLI, AvailableAppliCommand);
        this.addCommand(BuilderEvent.EVENT_START_BUILD_PROCESS, StartBuildCommand);
        this.addCommand(BuilderEvent.EVENT_JONAS_VERSION, JonasVersionCommand);
        this.addCommand(BuilderEvent.EVENT_DOWNLOAD_FILE, DownloadFileCommand);
        this.addCommand(BuilderEvent.EVENT_DOWNLOAD_ZIP_FILE, DownloadZipFileCommand);
        this.addCommand(BuilderEvent.EVENT_GET_OUTPUT_CONTENT, GetOutputContentCommand);
        this.addCommand(BuilderEvent.EVENT_SAVE_STARTER_INFO_IN_FILE, SaveStarterCommand);
        this.addCommand(BuilderEvent.EVENT_LOAD_STARTERS, LoadStartersCommand);
        this.addCommand(BuilderEvent.EVENT_JONAS_SERVICES, GetJonasServicesCommand);
        this.addCommand(BuilderEvent.EVENT_IS_VALID_URL, IsValidUrlCommand);
        this.addCommand(BuilderEvent.EVENT_SET_STARTER_PATH, SetStartersPathCommand);
        this.addCommand(BuilderEvent.EVENT_DELETE_STARTER, DeleteStarterCommand);
        this.addCommand(BuilderEvent.EVENT_JONAS_FOLDERS, GetJonasFoldersCommand);
        this.addCommand(BuilderEvent.EVENT_STOP_BUILD_PROCESS, StopBuildCProcessCommand);
    }

    public function removeCommands():void {
        removeCommand(BuilderEvent.EVENT_AVAILABLE_APPLI);
        removeCommand(BuilderEvent.EVENT_START_BUILD_PROCESS);
        removeCommand(BuilderEvent.EVENT_JONAS_VERSION);
        removeCommand(BuilderEvent.EVENT_DOWNLOAD_FILE);
        removeCommand(BuilderEvent.EVENT_DOWNLOAD_ZIP_FILE);
        removeCommand(BuilderEvent.EVENT_GET_OUTPUT_CONTENT);
        removeCommand(BuilderEvent.EVENT_SAVE_STARTER_INFO_IN_FILE);
        removeCommand(BuilderEvent.EVENT_LOAD_STARTERS);
        removeCommand(BuilderEvent.EVENT_JONAS_SERVICES);
        removeCommand(BuilderEvent.EVENT_IS_VALID_URL);
        removeCommand(BuilderEvent.EVENT_SET_STARTER_PATH);
        removeCommand(BuilderEvent.EVENT_DELETE_STARTER);
        removeCommand(BuilderEvent.EVENT_JONAS_FOLDERS);
        removeCommand(BuilderEvent.EVENT_STOP_BUILD_PROCESS);
    }
}
}
